#include "alg_types.hpp"

#include "../img/access/img_access_copy.hpp"
#include "../util/util_registry.hpp"

class alg_grayscale: public alg_mono1 {
public:
  alg_grayscale(const CtorArg&);
  virtual ~alg_grayscale();
public:
  virtual char const* name(){return s_name();}
  static char const* s_name(){return "grayscale";}
private:
  virtual void process(const img_data& src, 
    const win_event_vectorAbstract&, int msDayUtc,
    img_data& dst);
};

namespace{
  util::RegistryCreator<alg_base,alg_grayscale> creator;
}
  

alg_grayscale::alg_grayscale(const CtorArg& arg):
  alg_mono1( img_fmt(arg.fmt.width(), arg.fmt.height(), 1))
{}
alg_grayscale::~alg_grayscale(){}



void alg_grayscale::process(
  const img_data& src,
  const win_event_vectorAbstract&, int,
  img_data& dst)
{
  dst.reformat(img_fmt(
    src.fmt().width(), 
    src.fmt().height(), 1)
  );

  img_access_copy(src, dst);
}
