#ifndef cli_dev_hpp
#define cli_dev_hpp

#include <string>
#include <vector>

/******************************************************
*
** cli_dev.hpp by Sinisa Segvic:
*
** holds hardware component descriptions
** parsed from the command line
*
*******************************************************/

class cli_dev{
public:
  enum Type {sentinel=-1, 
    // Video types
    Grab, Win, File, Net, 
    // Default type
    Null, 
    // Hardware types
    Camera, PTU, 
    countId};
private:
  std::string name_;
  Type type_;
  std::string id_;
  std::vector<int> par_;
  int from_;
  int to_;
public:
  cli_dev(char const* name="dumb", Type=Null, char const* id="uncalibrated");
  ~cli_dev();
public:
  void setName(char const*);
  void setType(Type t);
  void setId(char const*);

  void pushPar(int p);
  void setPar(const std::vector<int>& p);
  void setRange(int f, int t);
public:
  char const* name() const;
  Type type() const;
  char const* id() const;
  int szPar() const;
  int par(int i) const;
  int from() const;
  int to() const;
};

std::ostream& operator<<(std::ostream& os, const cli_dev& d);



#endif
