#ifndef cli_wrap_hpp
#define cli_wrap_hpp


/******************************************************
*
** cli_wrapAbstract.hpp by Sinisa Segvic:
*
** provides line based io capabilities
* 
*******************************************************/

#include "cli_wrapAbstract.hpp"

#include <boost/smart_ptr.hpp>

#include <iosfwd>

class cli_wrap_imp;


class cli_wrap:
  public cli_wrapAbstract
{
private:
  boost::scoped_ptr<cli_wrap_imp> pimp;
public:
  cli_wrap(
    std::istream& is, 
    std::ostream& os,
    std::ostream& ms);
  virtual ~cli_wrap();
public:
  virtual char const* get();
  virtual bool eof();
  virtual void put(char const* );
  virtual void msg(char const* );
};

#endif
