#include "cvsh_createAlg.hpp"

#include "../img/img_data.hpp"

#include "../alg/alg_base.hpp"

#include "../util/util_registry.hpp"

#include <assert.h>

#include <iostream>


alg_base* cvsh_createAlg(
  std::ostream& os,
  char const* strAlg, 
  const img_fmt& fmt)
{
  alg_base* pAlg=0;
  util::Registry& reg=util::Registry::instance();
  util::Registry::Iterator it=
    reg.find<alg_base>(strAlg);
  if (it != reg.end<alg_base>()){
    pAlg=reg.create<alg_base>(
      it, alg_base::CtorArg(fmt));
  } else{
    pAlg=reg.create<alg_base>(
      "dllStub", alg_base::CtorArg(fmt, strAlg));
  }

  os <<"  Created alg_base: " <<strAlg <<std::endl;
  return pAlg;
}



