#include "grid_draw_colours.hpp"

#include <assert.h>
 
grid::draw_colours::draw_colours(){
  vec.push_back(Rgb(0x00,0x00,0xff));
  vec.push_back(Rgb(0x00,0xff,0x00));
  vec.push_back(Rgb(0xff,0x00,0x00));
 
  vec.push_back(Rgb(0x00,0xff,0xff));//cyan
  vec.push_back(Rgb(143, 188, 143));//dark olive green
  vec.push_back(Rgb(0xff,0xa5,0x00));//orange
  //vec.push_back(Rgb(0xff,0x00,0xff));//magenta

  vec.push_back(Rgb(0xa0,0x20,0xf0));//purple
  vec.push_back(Rgb(0x2e,0x8b,0x57));//sea green
  vec.push_back(Rgb(0xa5,0x2a,0x2a));//brown

  vec.push_back(Rgb(0xff,0x00,0x80));
  vec.push_back(Rgb(0x80,0xff,0x00));
  vec.push_back(Rgb(0xff,0x80,0x00));

  vec.push_back(Rgb(0x40,0x80,0xff));
 
  //vecGrey
  //the first entry must be black
  vecGrey.push_back(Rgb(0x00,0x00,0x00));
  //the second entry must be white
  vecGrey.push_back(Rgb(0xff,0xff,0xff));
  //even entries gradually rise 
  //from black towards 50% grey
  vecGrey.push_back(Rgb(0x20,0x20,0x20));
  //odd entries gradually fall
  //from white towards 50% grey
  vecGrey.push_back(Rgb(0xe0,0xe0,0xe0));
  vecGrey.push_back(Rgb(0x40,0x40,0x40));
  vecGrey.push_back(Rgb(0xc0,0xc0,0xc0));
  vecGrey.push_back(Rgb(0x60,0x60,0x60));
  vecGrey.push_back(Rgb(0xa0,0xa0,0xa0));
  //50% grey must be the last entry
  vecGrey.push_back(Rgb(0x80,0x80,0x80));
}
grid::draw_colours& grid::draw_colours::instance(){
  static grid::draw_colours theInstance;
  return theInstance;
}
 
 
const grid::draw_colours::Rgb& grid::draw_colours::colour(int i) const{
  if (i>=0){
    int index=i%static_cast<int>(vec.size());
    return vec[index];
  } else{
    return grey(-i-1);
  }
}
const grid::draw_colours::Rgb& grid::draw_colours::grey(int i) const{
  assert(i>=0);
  if (i<0) i=0;

  //oo maps to grey 50%
  if (i>=static_cast<int>(vecGrey.size()))
    i=static_cast<int>(vecGrey.size())-1;

  return vecGrey[i];
}
const grid::draw_colours::Rgb& grid::draw_colours::bw(bool white) const{
  static Rgb b(0x00,0x00,0x00);
  static Rgb w(0xff,0xff,0xff);
  return white?w:b;
}
 
 
