// a simple class mapping indices
// to perceptually different colours

#include <vector>

namespace grid{

class draw_colours{
public:
  //Local class Rgb
  struct Rgb{
    int rgb_[3];
    Rgb(int r, int g, int b){
      rgb_[0]=r; rgb_[1]=g; rgb_[2]=b;
    }
  };
public:
  //we are singleton
  static draw_colours& instance();

  //i<0 => returns grey(-1-i)
  const Rgb& colour(int i) const;
  //zero        : black
  //one         : white
  //even numbers: gradient from black to gray
  //odd  numbers: gradient from white to gray
  const Rgb& grey(int) const;
  const Rgb& bw(bool) const;
private:
  std::vector<Rgb> vec;
  std::vector<Rgb> vecGrey;
  draw_colours();
};
 
}
