#include "grid_draw_file.hpp"

#include "../../util/util_string.hpp"
//#include "../../util/util_fs.hpp"


/********************************************
*
**  grid::draw_file 
*
**  grid::draw to a vector file
*
*********************************************/

#include <fstream>


////////////////////////////////////////////
//  construction
static std::ostream* createStream(
  char const* name)
{
  //std::string logPath=util_fs::getLogDir();
  //logPath+=name;
  //std::string unique=
  //  util_fs::uniqueFilename(logPath.c_str());
  return new std::ofstream(
    name, std::ios::out);
}

grid::draw_file::draw_file(
  int x_f, int x_o, int y_f, int y_o,
  char const* filename)
:
  draw_rgb(x_f,x_o, y_f,y_o),
  os_(* createStream(filename)),
  ownsStream_(true)
{
  checkStream();
}

grid::draw_file::draw_file(
  int x_f, int x_o, int y_f, int y_o,
  std::ostream& os)
:
  draw_rgb(x_f,x_o, y_f,y_o),
  os_(os),
  ownsStream_(false)
{
  checkStream();
}

grid::draw_file::~draw_file(){
  if (ownsStream_)
    delete &os_;
}



////////////////////////////////////////////
//  operations

void grid::draw_file::checkStream(){
  if (!os_.good())
    throw "grid::draw_file::checkStream - "
          "the obtained stream is not valid";
}

std::ostream& grid::draw_file::os(){
  return os_;
}


