#include "grid_region.hpp"

#include "../../util/util_math.hpp"

#include <algorithm>

grid::Region::Region(){
  reset();
}

grid::Pixel grid::Region::pos() const{
  return grid::Pixel(
    util_math::round(posx_),
    util_math::round(posy_)
  );
}

void grid::Region::normalize(){
  size_t n=size();
  if (n==0) {
    n=1;
    assert(0);
  }
  posx_/=n;
  posy_/=n;
  std::sort(begin(),end(), less);
}
void grid::Region::reset(){
  clear();
  left_=bottom_=INT_MAX;
  right_=top_=-1;
  posx_=0;
  posy_=0;
}

int grid::Region::width() const {
  int w=right_-left_;
  assert (w>0);
  return w;
}

int grid::Region::height() const {
  int h=top_-bottom_;
  assert (h>0);
  return h;
}


