#ifndef grid_region_hpp
#define grid_region_hpp

#include "../root/grid_primitives.hpp"

#include "../../util/util_cxx.hpp"

namespace grid{

  class Region:
    public std::vector<Pixel>
  {
    double posx_;
    double posy_;
    int top_;
    int bottom_;
    int left_;
    int right_;
  public:
    Region();
  public:
    Pixel pos() const;
    double posx() const { return posx_;}
    double posy() const { return posy_;}
    int top() const {return top_;}
    int bottom() const {return bottom_;}
    int left() const {return left_;}
    int right() const {return right_;}
    int width() const;
    int height() const;
  public:
    void updateLeft(int l)  {if (l<left_)   left_=l;}
    void updateRight(int r) {if (r>right_)  right_=r;}
    void updateTop(int t)   {if (t>top_)    top_=t;}
    void updateBottom(int b){if (b<bottom_) bottom_=b;}
    void updatePos(int sumx, int sumy){
      posx_+=sumx;
      posy_+=sumy;
    }
    void normalize();
    void reset();
  };

  class WtRegion:
    public Weighted,
    public Region
  {};

  //inline bool lessThanRegion(
  //  const grid::Region& lhs, 
  //  const grid::Region& rhs)
  //{
  //  return lhs.size()<rhs.size();
  //}
}

#endif

