#ifndef img_access_wrap_hpp
#define img_access_wrap_hpp

/******************************************************
*
*  component: img_access
*  concept: img_accessor
*  class: img_access_wrap
*
** a wrapper around pointer to pixel
** making it an instance of img_accessor concept
** which is used fo parameterizing 
** img_accessor_guard class template
*
** introduced for portability with MSVC
** which lacks partial template specialization
*
** should be parameterized with
** img_pix classes which define type Data
*
** author: Sinisa Segvic
** version 1.0 (2001-02-26)
*
*******************************************************/

template <class Pixel>
class img_access_wrap{
public:
  typedef Pixel  value_type; 
  typedef Pixel* pointer;
  typedef Pixel& reference;
                                             
  operator pointer() const {return ptr_;}  
  void operator+=(int o) {ptr_+=o;}           
private:                                     
  pointer ptr_;                              
};

template <class Pixel>
class img_access_wrap_const{
public:
  typedef Pixel  value_type; 
  typedef Pixel const* pointer;
  typedef const Pixel& reference;
                                             
  operator pointer() const {return ptr_;}  
  void operator+=(int o){ptr_+=o;}           
private:                                     
  pointer ptr_;                              
};
#endif
