#ifndef img_io_load_ras_hpp
#define img_io_load_ras_hpp

/******************************************************
*
** img_io_load_ras.cpp by Sinisa Segvic
*
** reading images from ras file format
** to a img_data structure
*
** depends on:
**   img_data, img_io_load, img_util, 
**   util_ras 
*
*******************************************************/
#include <boost/smart_ptr.hpp>

class img_io_load_rasImp;
class img_data;
class img_fmt;

class img_io_load_rasMany{
public:
  img_io_load_rasMany(char const* name);
  virtual ~img_io_load_rasMany();

  int count();
  const img_fmt& fmt();

  void seek(int frame);
  void operator()(img_data&);
private:
  boost::scoped_ptr<img_io_load_rasImp> pimp;
};

#endif

