#include <stdio.h>

#include <string>
#include <stdexcept>

#include "img_io_save.hpp"

struct img_io_save_imp{
  void check(char const*);
  FILE *pf;
  bool pf_owner;
};

void img_io_save_imp::check(char const* fn){
  if (!pf || ferror(pf)!=0){
    std::string msg("img_io_save_imp::check "
        "- file check failed (");
    msg+=fn; msg+=")";
    throw std::runtime_error(msg);
  }
}

img_io_save::img_io_save(char const* name){
  pimp=new img_io_save_imp;
  pimp->pf=::fopen(name,"wb");
  pimp->check(name);
  pimp->pf_owner=true;
}

img_io_save::img_io_save(){
  pimp=new img_io_save_imp;
  pimp->pf=stdout;
  pimp->check("<pipe>");
  pimp->pf_owner=false;
}


img_io_save::~img_io_save(){
  if (pimp->pf_owner) 
    ::fclose(pimp->pf);
  delete pimp;
}


void img_io_save::write(void const* buf, int size){
  ::fwrite(buf, 1, size, pimp->pf);
  pimp->check("<while writing>");
}



