#ifndef img_io_save_hpp
#define img_io_save_hpp

class img_data;

/******************************************************
*
*  component:
*     img_io_save
*
** manages output of images
** described by img_data
** in various image formats
*
** version 4.5 (2001-03-05)
*
*******************************************************/

struct img_io_save_imp;

class img_io_save{
  img_io_save_imp *pimp;
protected:
  //the file must be valid
  img_io_save(char const* name);
  //stdout assumed
  img_io_save();
public:
  virtual ~img_io_save();

  //img must be valid
  virtual void operator()(const img_data& img) =0;

protected:
  void write(void const* buf, int size);
private:
  //forbidden
  img_io_save(img_io_save&);
  void operator=(img_io_save&);
};


#endif

