#ifndef img_io_save_util_h 
#define img_io_save_util_hpp

#include <iosfwd>

class img_data;
class img_io_save;

/******************************************************
*
*        img_io_save_util.h  by Sinisa Segvic
*
** reading and writing images represented by img_data
** (a facade for img_io_save hierarchy)
*
** depends on:
**   img_data,
**   img_io_save and its concrete implementations,
**   util_c
*
** version 4.5 (2001-03-05)
*
*******************************************************/

struct img_io_save_util{
public:
  //img is written to std::cout in Sun raster format
  static void save(const img_data& img);

  //outfile must point to a valid disk file and
  //the format is deduced from extension
  static void save(const img_data& img, char const* outfile);
  static void savegrey(const img_data& img, char const* outfile);

  //create img_io_save object from the existing img
  static img_io_save* createSaver(char const* extension);
};



#endif
