#ifndef ipp_annotations_hpp
#define ipp_annotations_hpp

#include "../win/ann/win_ann_abstract.hpp"

namespace grid{
  class WtRegion;
  class Region;
  class WtContourWt;
  class Contour;
  class Point2D;
  class Line;
}

#include <vector>


namespace ipp{
  //ContourWt
  void annotateContoursNodata(
    const std::vector<grid::WtContourWt>& contours,
    win_ann_abstract& ann);
  void annotateContoursId(
    const std::vector<grid::WtContourWt>& contours,
    win_ann_abstract& ann);
  void annotateContoursIdSz(
    const std::vector<grid::WtContourWt>& contours,
    win_ann_abstract& ann);

  //plain Contour
  void annotatePlainContoursIdSz(
    const std::vector<grid::Contour>& contours,
    win_ann_abstract& ann);
  void annotatePlainContoursId(
    const std::vector<grid::Contour>& contours,
    win_ann_abstract& ann);

  //Regions
  void annotateRegion(
    const grid::WtRegion& region, 
    int colour, char const* str,
    win_ann_abstract& ann);
  void annotateRegions(
    const std::vector<grid::WtRegion>& regions,
    win_ann_abstract& ann);

  //Rectangle
  void annotateRectangle(
    int left, int bottom, int right, int top,
    int colour, char const* str,
    win_ann_abstract::LineStyle style, 
    int width,
    win_ann_abstract& ann);
}

#endif

