#ifndef ipp_homography_h
#define ipp_homography_h

/***********************************
*  ipp_homography.h by Sinisa Segvic
*
** Applies the inverse of the given homography
*  to the source image and
*  stores results to the destination
*
************************************/

class img_data;
#include <boost/numeric/ublas/matrix.hpp>

namespace ipp{

void homography(
  const img_data& src,
  const boost::numeric::ublas::matrix<double>& Hi,
  img_data& dst);
    
// end namespace alg
}

#endif
