#ifndef ipp_negate_hpp
#define ipp_negate_hpp

class img_data;

namespace ipp{
  // Let scalar pixels in img_src be in <0..M>
  // then each pixel of img_dst is calculated as:
  //    M-v,
  // where v is value of the corresponding pixel
  // of the source image
  void negate(
    const img_data& src, 
    img_data& dst);

  // Let scalar pixels in img_src be in <0..M>
  // then each pixel of img_dst is calculated as:
  //    limit-v,
  // where v is value of the corresponding pixel
  // of the source image, and limit<M
  void negate(
    const img_data& src, double limit,
    img_data& dst);
}

#endif

