#ifndef ipp_radial_hpp
#define ipp_radial_hpp

/***********************************
*  ipp_radial.hpp by Sinisa Segvic
*
** undoes radial distortion effects
** in images acquired with a camera
** with known radial distortion 
** parameters k1 and k2
*
** (linear parametres alpha, u0, v0
**  also need to be known)
*
************************************/

class img_data;

namespace ipp{

void radial(
  const img_data& src,
  double alpha,
  double u0, double v0,
  double k1, double k2,
  img_data& imgDst);
    
// end namespace ipp
}

#endif
