#ifndef ipp_regionGrowing_hpp
#define ipp_regionGrowing_hpp

class img_data;
#include "../grid/root/grid_primitives.hpp"
#include "../grid/root/grid_region.hpp"

namespace ipp{
  // * blob is an 8-connected colection of pixels
  //   whose grey level is greater than thPix 
  // * caveat, input images must have zeroed
  //   margins, otherwise the algorithm crashes!
  
  // * grows single blob in imgGray,
  //   starting from xpos
  // * returns count of pixels in blob
  int growBlob(
    const img_data& imgGray, //pixel magnitudes
    int thGray, const grid::Pixel& pos,
    grid::WtRegion& blob);
  // * finds out all blobs in imgGray 
  // * blobs containing less than thBlob pixels 
  //   are discarded
  // * returns count of blobs
  int growBlobs(
    const img_data& imgGray, int margin, img_data& imgDst, 
    int thGray, int thBlob,
    std::vector<grid::WtRegion>& blobs);
}


#endif

