#ifndef ipp_drawPoints_hpp
#define ipp_values_hpp

class img_data;

#include "../grid/root/grid_primitives.hpp"
#include "../math/la/math_la2D.hpp"

#include <vector>

namespace ipp{
  int putValues(
    const std::vector<grid::Pixel>& points,
    const std::vector<double>& src,
    img_data& dst);
  int getValues(
    const std::vector<grid::Pixel>& points,
    const img_data& src,
    std::vector<double>& dst);

  // get image values at real-valued points
  // using the bilinear approximation
  int getValues(
    const std::vector<math::Point2D>& points,
    const img_data& src,
    std::vector<double>& dst);

}

#endif
