#ifndef ui_report_hpp
#define ui_report_hpp

#include <iosfwd>
#include <vector>
#include <utility>
#include <string>

#include "ui_reportAbstract.hpp"

/******************************************************
*
**  ui_report by Sinisa Segvic:
*
** reporting procedures related to the
** domain of the class ui
*
*******************************************************/

class ui_report:
  public ui_reportAbstract
{
  typedef std::pair<std::string, int> Entry;
  std::vector<Entry> vec_;  
public:
  ui_report();
  ~ui_report();

  virtual void push_back(char const*, int);
  virtual char const* description(int) const;
  virtual int duration(int) const;
  virtual int size() const;
};

void ui_profile(
  std::ostream& os,
  char const* description, 
  const ui_reportAbstract& p,
  long frequency);
void ui_reportBatch(
  std::ostream& os,
  int nFrames, int nClocks, 
  long frequency);
void ui_usage(
  std::ostream& os);


#endif
