#ifndef util_cxx_hpp
#define util_cxx_hpp

// C++ utilities of general interest


#include <string>
#include <vector>
#include <math.h>
#include <assert.h>

namespace util_cxx{
//template abs function
  template <class T> inline T abs(T val){
    return (val<0)?-val:val;
  }
  template <> inline int abs(int val){
    // int q = l >> (sizeof(int) * 8 - 1); 
    // return ( l ^ q ) - q;
    // return ::abs(val);
    return (val<0)?-val:val;
  }
  template <> inline float abs(float val){
    return static_cast<float>(::fabs(val));
  }
  template <> inline double abs(double val){
    return ::fabs(val);
  }

//checkedVector
  template <class T>
  class cvector:
    public std::vector<T>
  {
  public:
    cvector(int n=0, const T& t=T()):
      std::vector<T>(n,t)
    {}
    T& operator[](int pos){
      assert(pos>=0 && 
        pos<static_cast<int>(std::vector<T>::size()));
      return *(std::vector<T>::begin()+pos);
    }
    const T& operator[](int pos) const {
      assert(pos>=0 && 
        pos<static_cast<int>(std::vector<T>::size()));
      return *(std::vector<T>::begin()+pos);
    }
  };
}


#endif
