#ifndef util_debug_h 
#define util_debug_hpp

#include "util_endian.hpp"
#include <boost/scoped_ptr.hpp>
class LogImp;

namespace util{
  class Log{
    boost::scoped_ptr<LogImp> pimp;
  public:
    Log(char const* file);
    ~Log();

    void prolog();
    void flush();

    Log& operator<<(char const* str);
    Log& operator<<(int d);
    Log& operator<<(unsigned int d);
    Log& operator<<(unsigned long d);
    Log& operator<<(long d);
    Log& operator<<(double f);
  };

  class NoLog{
  public:
    NoLog(char const* ){}
    ~NoLog(){}

    void prolog(){}
    void flush(){}

    NoLog& operator<<(char const* ){return *this;}
    NoLog& operator<<(int ){return *this;}
    NoLog& operator<<(unsigned int ){return *this;}
    NoLog& operator<<(unsigned long ){return *this;}
    NoLog& operator<<(long ){return *this;}
    NoLog& operator<<(double ){return *this;}
  };
}

#endif

