#ifndef util_dll_hpp
#define util_dll_hpp

/****************************************
*
*  component:
*     util_dll
*
** An abstraction of the explicit 
** access to dynamic libraries
*
** author: Sinisa Segvic
** version 1.0 (2001-09-14)
*
****************************************/

#include <boost/smart_ptr.hpp>

struct util_dll_imp;

#if defined(_WIN32)
 #define DECLSPEC __stdcall
#else
 #define DECLSPEC 
#endif


class util_dll{
public:
  util_dll(char const* name);
  ~util_dll();

  typedef void (* VoidFunInt)(int);
  VoidFunInt getFun(char const* name);
private:
  boost::scoped_ptr<util_dll_imp> pimp;
};


#endif
