#include "util_dll.hpp"

#include <string>
#include <stdexcept>

#include <dlfcn.h>

/////////////////////////////
// util_dll private implementation

struct util_dll_imp{
  util_dll_imp(void*);
  void* handle;
};

util_dll_imp::util_dll_imp(
  void* hnew)
:
  handle(hnew)
{}

/////////////////////////////
// util_dll implementation

util_dll::util_dll(char const* name):
  pimp (new util_dll_imp(
              dlopen(name, RTLD_NOW)))
{
  if (pimp->handle==0) {
    std::string str;
    str="util_dll::util_dll - could not load dll, dlopen reports:\n";
    str+=dlerror();
    throw std::runtime_error(std::string(str));
  }
}


util_dll::~util_dll(){
  dlclose(pimp->handle);
}


util_dll::VoidFunInt 
util_dll::getFun(char const* name)
{
  util_dll::VoidFunInt rv=
    (util_dll::VoidFunInt)
      dlsym(pimp->handle, name);
  if (rv==0) {
    static std::string str;
    str="util_dll::util_dll - could not resolve symbol, dlsym reports:\n";
    str+=dlerror();
    throw std::runtime_error(std::string(str));
  }
  return rv;
}
  
