#include "util_dll.hpp"

#include <string>
#include <sstream>
#include <stdexcept>

#include <windows.h>

/////////////////////////////
// util_dll private implementation

struct util_dll_imp{
  util_dll_imp(HMODULE);
  HMODULE h;
};

util_dll_imp::util_dll_imp(
  HMODULE hnew)
:
  h(hnew)
{}



/////////////////////////////
// util_dll implementation

util_dll::util_dll(char const* name):
  pimp (new util_dll_imp(LoadLibrary(name)))
{
  if (pimp->h==0) {
    DWORD dw=GetLastError();
    std::ostringstream ss;
    ss <<"util_dll::util_dll - ";
    ss <<"could not open library \'" <<name <<"\'";
    ss <<" (" <<dw <<")";
    throw std::runtime_error(std::string(ss.str()));
  }
}


util_dll::~util_dll(){
  FreeLibrary(pimp->h);
}


util_dll::VoidFunInt 
util_dll::getFun(char const* name)
{
  util_dll::VoidFunInt rv=
    (util_dll::VoidFunInt)
    GetProcAddress(pimp->h, name);
  if (rv==0) {
    char const* intro=
      "util_dll::util_dll - could not resolve symbol ";
    DWORD dw=GetLastError();
    std::ostringstream ss;
    ss <<intro;
    ss <<'(' <<dw <<')';
    throw std::runtime_error(std::string(ss.str()));
  }
  return rv;
}
  
