#include "util_endian.hpp"

bool util_endian::endianBig(){
  static int i=1;
  static void* pv=&i;
  static char* pc=static_cast<char*>(pv);
  static char c=*pc;
  static bool be=(c==0);

  return be;
}

  
void util_endian::putLittle2(int num, ONE_BYTE* buf){
  *buf++=(ONE_BYTE)(num &0xff);
  num>>=8;
  *buf=(ONE_BYTE)(num &0xff);
}
void util_endian::putLittle4(int num, ONE_BYTE* buf){
  *buf++=(ONE_BYTE)(num &0xff);
  num>>=8;
  *buf++=(ONE_BYTE)(num &0xff);
  num>>=8;
  *buf++=(ONE_BYTE)(num &0xff);
  num>>=8;
  *buf=(ONE_BYTE)(num &0xff);
}

int util_endian::getLittle2(ONE_BYTE const* buf){
  unsigned int rv=*buf++;
  rv+=(*buf)<<8;
  return rv;
}
int util_endian::getLittle4(ONE_BYTE const* buf){
  unsigned int rv=*buf++;
  rv+=(*buf++)<<8;
  rv+=(*buf++)<<16;
  rv+=(*buf)<<24;
  return rv;
}


void util_endian::putBig2(int num, ONE_BYTE* buf){
  *buf++=(ONE_BYTE)((num>>8) & 0xff);
  *buf  =(ONE_BYTE)(num & 0xff);
}
void util_endian::putBig4(int num, ONE_BYTE* buf){
  *buf++=(ONE_BYTE)((num>>24) & 0xff);
  *buf++=(ONE_BYTE)((num>>16) & 0xff);
  *buf++=(ONE_BYTE)((num>>8) & 0xff);
  *buf=  (ONE_BYTE)(num & 0xff);
}

int util_endian::getBig2(ONE_BYTE const* buf){
  unsigned int rv=*buf++;
  rv<<=8;
  rv+=*buf;
  return rv;
}
int util_endian::getBig4(ONE_BYTE const* buf){
  unsigned int rv=*buf++;
  rv<<=8;
  rv+=*buf++;
  rv<<=8;
  rv+=*buf++;
  rv<<=8;
  rv+=*buf;
  return rv;
}
