#ifndef util_fs_hpp
#define util_fs_hpp

/******************************************************
*
*        util_fs.cpp  by Sinisa Segvic
*
** Various file-system utility functions
*
*******************************************************/

#include <vector>
#include <string>

namespace util_fs{
  // returns a unique file name based on the given stem
  // directories in the stem must be writable!
  std::string uniqueFilename(char const* stem);
  // returns a writable directory terminated with
  // the suitable path delimiter (/ or \)
  std::string getLogDir();
  std::string getTmpDir();
  
  char dirDelimiter();
  const char* defaultTempDir();
  
  bool checkFileWrite(char const* p);
  bool checkFileRead(char const* p);

  bool readDir(char const* dir, std::vector<std::string>& entries);
  bool isDir(char const* path);
}

#endif

