#include "util_fs.hpp"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <dirent.h>

#include <string>
#include <vector>
#include <stdexcept>

#include <iostream>


char util_fs::dirDelimiter(){
  return '/';
}
const char* util_fs::defaultTempDir(){
  return "/tmp";
}


bool util_fs::checkFileWrite(char const* p){
  return access(p, W_OK)==0;
}
bool util_fs::checkFileRead(char const* p){
  return access(p, F_OK)==0;
}



bool util_fs::readDir(char const* path, 
  std::vector<std::string>& entries)
{
  DIR *dhandle=opendir(path);
  if (!dhandle) 
    return false;
  
  while (1){
    struct dirent *entry = readdir(dhandle);
    if (!entry) 
      break;

    if (entry->d_name[0] !='.') {
      std::string str(path);
      entries.push_back(str+entry->d_name);
      // std::cerr <<entry->d_name <<"\n";
    }
  }
  std::sort(entries.begin(), entries.end());

  closedir(dhandle);
  return true;
}


bool util_fs::isDir(char const* path){
  struct stat buf;
  stat (path, &buf);
  return S_ISDIR(buf.st_mode);
}



