#ifndef util_math_hpp
#define util_math_hpp

/******************************************************
*
*        util_math.cpp  by Sinisa Segvic
*
** Various C-style math functions
*
*******************************************************/

#include <math.h>

struct util_math{
//inline functions
  static double atan2check(double a, double b);
  static bool fnegative(double a);
  static int round(double m);
};



inline double util_math::atan2check(double a, double b){
#if defined(_MSC_VER)
  //fix for msvc at alpha architecture
  if (a==0 && b==0) 
    return 0;
#endif
  return ::atan2(a,b);
}
inline bool util_math::fnegative(double a){
  return a<0;
}

inline int util_math::round(double m){
  if (m<0) m+=-.5;
  if (m>0) m+=.5;
  return static_cast<int>(m);
}

#endif
