#ifndef util_string_hpp
#define util_string_hpp

#include <string>
#include <vector>

namespace util_string{
  //generic strings
  int compareNoCase(char const *s, char const *t);
  void tolower(std::string& );
  void trimWs(std::string& );
  void fixBackslashEscapes(
    char const* src, std::string& dst);
  void incrementName(std::string& name);
  void indent(
    const std::string& str, 
    std::string& strout);
  int strToInt(const std::string&);
  
  // perl-like functions
  void split(char const*s, char delim, std::vector<std::string>& vec);

  // filenames
  char const* getFileExtension(char const *s);
  void retractPath(
    char const* fullPath, std::string& fileName);
  void splitPath(
    char const* fullPath, std::string& dir, std::string& file);

  // ip adresses
  int getHostNumber(char const* ipaddr);
}

#endif

