/******************************************************
*
*        util_time_linux.cpp  by Sinisa Segvic
*
** timing and profiling on unix systems
** using gettimeofday()
*
*******************************************************/
#include <time.h>
#include <sys/time.h>


#include "util_time.hpp"

#ifndef NTIMEPROFILE

util_time::util_time(){
  frequency_=10*1000;
}

util_time::Data util_time::operator()(){
  struct timeval tv;
  struct timezone tz;

  gettimeofday(&tv, &tz);

  long sec_this_day=tv.tv_sec % (24*60*60);

  return sec_this_day*10*1000 + tv.tv_usec/100;
}

  
int util_time::secEpoch(){
  time_t tmUnix;
  time (&tmUnix );
  return tmUnix; 
}

int util_time::msDayUtc(){
  struct timeval tv;
  struct timezone tz;

  gettimeofday(&tv, &tz);

  int sec_this_day=tv.tv_sec % (24*60*60);
  return sec_this_day*1000 + tv.tv_usec/1000;
}
#endif
