#ifndef vd_file_avi_hpp
#define vd_file_avi_hpp

/******************************************************
*
*  vd_file_avi by Sinisa Segvic:
*
** storing a sequence of image frames 
** with common format to an .avi file
*
** vd_file_avi IS_A vd_file IS_A vd_base
*
** uses util/util_avi
*
*******************************************************/


#include "vd_file.hpp"

namespace util{
  class AviWrite;
}

class vd_file_avi: public vd_file
{
  util::AviWrite& aw_;
public:
  vd_file_avi(
    const img_fmt& f,
    const char* filename); 
public:
  virtual ~vd_file_avi();

//vd_file_util attributes
public:
  static char const* extension(){ return "avi"; }

//vd_file operations
public:
  virtual void operator()(const img_data& img, int time=0, int frame=-1);
};



#endif

