#include "vd_file_single.hpp"

#include "../img/img_data.hpp"
#include "../img/io/img_io_save_util.hpp"

#include "../util/util_string.hpp"

#include <iostream>
#include <iomanip>

#include <sstream>
#include <string>



///////////////////////////////////////////
// vd_file_single private implementation data

struct vd_file_single_imp{
  vd_file_single_imp(char const* filename);

  size_t extPos;
  std::string extension;
  std::string basename;

  int count;

  bool null;
};

vd_file_single_imp::vd_file_single_imp(
  char const* filename)
:
  extPos(util_string::getFileExtension(filename)-filename),
  extension(filename+extPos, strlen(filename)-extPos),
  basename(filename, extPos-1),
  count(0),
  null(
    !strcmp(filename,"/dev/null") || 
    !strcmp(filename,"\\dev\\null") || 
    !strcmp(filename,"null")
  )
{ 
}



///////////////////////////////////////////
// vd_file_single member definitions
vd_file_single::vd_file_single(
  const img_fmt& fmt,
  char const* filename)
:
  vd_file(fmt),
  pimp(new vd_file_single_imp(filename))
{
}


vd_file_single::~vd_file_single(){
}

void vd_file_single::operator()(
  const img_data& img, 
  int, int)
{
  if (!pimp->null){
    std::ostringstream oss;
    oss <<pimp->basename <<'-';
    oss <<std::setw(5) <<std::setfill('0') <<pimp->count;
    oss <<'.' <<pimp->extension;

    img_io_save_util::save(img,oss.str().c_str());
  }

  pimp->count++;
}


