#ifndef vd_file_single_hpp
#define vd_file_single_hpp

/******************************************************
*
** vd_file_single by Sinisa Segvic:
*
** storing a sequence of image frames
** to a series of files with numbered names
** in formats supported by img_io_save_* components
*
** vd_file_single IS_A vd_file
*
** uses img/io/img_io_save
*
*******************************************************/


#include "vd_file.hpp"
#include <boost/smart_ptr.hpp>

struct vd_file_single_imp;

class vd_file_single: 
  public vd_file
{
  boost::scoped_ptr<vd_file_single_imp> pimp;
public:
  vd_file_single(const img_fmt& fmt, const char* filename);
  virtual ~vd_file_single();

//vd_file_util attributes
public:
  static char const* extension(){ return "";}

//vd_base attributes
public:
  virtual bool canReformat(){ return true;}
//vd_file operations
public:
  virtual void operator()(
    const img_data& img, int time=0, int frame=-1);
};

#endif

