#ifndef vd_file_srs_hpp
#define vd_file_srs_hpp

/******************************************************
*
** vd_file_srs by Sinisa Segvic:
*
** storing a sequence of image frames 
** with common format to an .srs file
** (sequence of images in SUN raster format)
*
** vd_file_srs IS_A vd_file IS_A vd_base
*
** uses util/util_srs
*
*******************************************************/


#include "vd_file.hpp"

struct vd_file_srs_imp;

class vd_file_srs: 
  public vd_file
{
  vd_file_srs_imp* pimp;
public:
  vd_file_srs(const img_fmt& fmt, const char* filename);
  vd_file_srs(const img_fmt& fmt);//stdout assumed
  virtual ~vd_file_srs();

//vd_file_util attributes
public:
  static char const* extension(){ return "srs"; }

//vd_file operations
public:
  virtual void operator()(const img_data& img, int time=0, int frame=-1);
};

#endif

