#include "vd_file_util.hpp"
#include "vd_file_srs.hpp"
#include "vd_file_avi.hpp"
#include "vd_file_single.hpp"

#include "../util/util_string.hpp"

#include <cassert>
#include <iostream>

vd_file* vd_file_util::create(
  const img_fmt& fmt,
  const char* name
){
  vd_file* pvdf;
  char const* ext=util_string::getFileExtension(name);
  if (!util_string::compareNoCase(ext, vd_file_srs::extension())){
    pvdf= new vd_file_srs(fmt, name);
  }
  else if (!util_string::compareNoCase(ext, vd_file_avi::extension())){
    pvdf= new vd_file_avi(fmt, name);
  }
  else{
    pvdf=new vd_file_single(fmt, name);
  }
  return pvdf;
}

