#ifndef vd_win_hpp
#define vd_win_hpp

/******************************************************
*
**  vd_win by Sinisa Segvic:
*
** showing a sequence of image frames 
** with variable format within a window
*
** vd_win IS_A vd_base
*
** uses win/
*
*******************************************************/


#include "vd_base.hpp"
#include <boost/smart_ptr.hpp>

class vd_win_imp;
class win_ann_abstract;
class win_base;

class vd_win: 
  public vd_base
{
//construction
public:
  vd_win(const img_fmt& f, char const* name);
  virtual ~vd_win();

//vd_base attributes
public:
  virtual bool isFile(){ return false;}
  virtual bool isWin(){ return true;}
  virtual bool canReformat(){ return true;}

//vd_base operations
public:
  virtual void operator()(
    const img_data& img, 
    int time=0, int frame=-1);

//vd_win attributes
public:
  win_base& win() const;
  char const* caption() const;

//vd_win operations
public:
  void size(int, int);
  void position(int, int);
  void caption(char const*);

  void operator()(
    const img_data& img, 
    const win_ann_abstract& a, 
    int time=0, int frame=-1);

  void resetTime();
  // returns the new recording state
  bool toggleRec();

private:
  boost::scoped_ptr<vd_win_imp> pimp;
};





#endif
