#include "vs_base.hpp"

#include <limits>

#include <assert.h>

vs_base::vs_base():
  frame_(0),
  from_(0),
  to_(-1)
{
}
vs_base::~vs_base(){}


//////////////////////////
// random access

int vs_base::tell(){
  int f=frame_-from_;
  assert(f>=0);
  return f;
}

void vs_base::seek(int f){
  f=f % size();
  if (f<0) f+=size();

  frame_=f+from_;
  assert(frame_>=0);
}

void vs_base::setRange(int from, int to){
  int total=count();

  to_=to;
  if (to_<0){
    to_=-1;
  } else if (to_<from_){
    to_=from_+1;
  } else if (to_>total){
    to_=total;
  }

  int toReal=(to_<0)? total: to_;
  from_=from;
  if (from_ >= toReal){
    from_ = toReal-1;
  }
  if (from_<0){
    from_=0;
  }  
  assert(from_>=0);
  
  seek(0);
}

int vs_base::size(){
  int to=(to_<0)? count(): to_;
  return to-from_;
}  

int vs_base::from(){
  return from_;
}  
int vs_base::to(){
  return to_;
}  


//////////////////////////
// operations

void vs_base::getFrame(img_data& d, int frame){
  seek(frame);
  getFrameSimple(d);
}
void vs_base::getNextFrame(img_data& d){
  getFrame(d, tell()+1);
}
