#ifndef vs_file_hpp
#define vs_file_hpp

/******************************************************
*
*        vs_file.hpp by Sinisa Segvic
*
** describes acquisition of a sequence of image
** frames with possibly variable format from a file
*
** vs_file IS_A vs_base
*
*******************************************************/

#include "vs_base.hpp"


class vs_file: 
  public vs_base
{
protected:
  vs_file();
public:
  virtual ~vs_file();
public:
  virtual bool isFile(){ return true;}
  virtual bool isLive(){ return false;}
  virtual char const* name()=0;
public:
  // from vs_base:
  //   virtual int count();
  //   int tell();
  //   void seek(int);
public:
  virtual const img_fmt& fmt()=0;
public:
  virtual int msDayUtc()=0;
private:
  virtual void getFrameSimple(img_data&)=0;
};


#endif
