#ifndef vs_file_avi_hpp
#define vs_file_avi_hpp

/******************************************************
*
*   vs_file_avi.hpp by Sinisa Segvic
*
** describes acquisition of a sequence of image
** frames with possibly variable format from an AVI file
*
** vs_file_avi IS_A vs_file IS_A vs_base
*
*******************************************************/

#include "vs_file.hpp"


class vs_file_avi_imp;

class vs_file_avi: 
  public vs_file
{
public:
  vs_file_avi(const char* filename);
  virtual ~vs_file_avi();

//vs_file_util attributes
public:
  static char const* extension(){ return "avi"; }

//attributes
public:
  virtual int count();
  virtual char const* name();
public:
  virtual const img_fmt& fmt();
public:
  virtual int msDayUtc();
private:
  virtual void getFrameSimple(img_data&);

//vs_file_avi data
private:
  vs_file_avi_imp* pimp;
};

#endif
