#include "vs_file_dir.hpp"

#include "../util/util_fs.hpp"

#include <string>
#include <vector>
#include <fstream>
#include <stdexcept>

#include <iostream>



// private helpers

namespace{
  bool pathsep(char c){
    return (c=='/' || c=='\\');
  }

  struct MyThrower{
    MyThrower(char const* name){
      context_="vs_file_dir (";
      context_+=name;
      context_+=") - ";
    }

    void operator()(const std::string &msg){
      throw std::runtime_error(context_+msg);
    }

    std::string context_;
  };


  std::vector<std::string> DirParser(
    char const* dirname)
  {
    std::vector<std::string> vecVsFile;
    MyThrower error(dirname);

    bool exists=util_fs::readDir(dirname, vecVsFile);
    if (!exists)
      error("access error or not a directory");
    
    for (int i=static_cast<int>(vecVsFile.size()); --i>=0;){
      if (util_fs::isDir(vecVsFile[i].c_str()))
        vecVsFile.erase(vecVsFile.begin()+i);
    }
      
    return vecVsFile;
  }
}








//////////////////////////////////////////////////
//vs_file_dir implementation

vs_file_dir::vs_file_dir(
  char const* name)
:
  vs_file_many(DirParser(name)),
  strDir_(name)
{
}

vs_file_dir::~vs_file_dir(){
}



//////////////////////////////////////////////////
//attributes
char const* vs_file_dir::name(){
  return strDir_.c_str();
}  
