#ifndef vs_file_dir_hpp
#define vs_file_dir_hpp

/******************************************************
*
*   vs_file_dir.hpp by Sinisa Segvic
*
** describes acquisition from multiple files
** located in the same directory
*
** vs_file_dir IS_A vs_file_many IS_A vs_file IS_A vs_base
*
*******************************************************/

#include "vs_file.hpp"
#include "vs_file_many.hpp"

#include<string>

class vs_file_dir: 
  public vs_file_many
{
public:
  vs_file_dir(char const* dirname);
  virtual ~vs_file_dir();

//vs_file_util attributes
public:
  static char const* extension(){ return "/"; }

//vs_base methods (most inherited from fs_file_many)
public:
  virtual char const* name();
  // virtual int count();
  // virtual const img_fmt& fmt();
  // virtual int msDayUtc();
  // virtual void getFrameSimple(img_data&);

// vs_file_dir data
private:
  std::string strDir_;
};


#endif


