#ifndef vs_file_single_hpp
#define vs_file_single_hpp

/******************************************************
*
*   vs_file_single.hpp by Sinisa Segvic
*
** describes acquisition from an one-image file
** through a vs_base interface,
** using img_io_load_* components
*
** vs_file_single IS_A vs_file IS_A vs_base
*
*******************************************************/

#include "vs_file.hpp"
#include <boost/smart_ptr.hpp>

class vs_file_single_imp;

class vs_file_single: 
  public vs_file
{
public:
  vs_file_single(char const* filename);
  virtual ~vs_file_single();

public:
  virtual int count(){return 1;};
  virtual char const* name();
public:
  virtual const img_fmt& fmt();
public:
  virtual int msDayUtc(){return 0;};
private:
  virtual void getFrameSimple(img_data&);

private:
  boost::scoped_ptr<vs_file_single_imp> pimp;
};


#endif
