#ifndef vs_file_srs_hpp
#define vs_file_srs_hpp

/******************************************************
*
*        vs_file_srs.hpp  by Sinisa Segvic
*
** reading frames with common format from a srs file
** (sequence of images in SUN raster format)
*
*******************************************************/

#include "vs_file.hpp"

struct vs_file_srs_imp;

class vs_file_srs: 
  public vs_file
{
//construction
public:
  vs_file_srs(char const* name);
  virtual ~vs_file_srs();

//vs_file_util attributes
public:
  static char const* extension(){ return "srs";}

//vs_base methods
public:
  virtual int count();
  virtual char const* name();
public:
  virtual const img_fmt& fmt();
public:
  virtual int msDayUtc();
private:
  virtual void getFrameSimple(img_data& );

// vs_file_srs data
private:
  vs_file_srs_imp *pimp;
};




#endif
