#ifndef vs_file_wmv_hpp
#define vs_file_wmv_hpp

/******************************************************
*
*   vs_file_wmv.hpp by Sinisa Segvic
*
** describes acquisition of a sequence of image
** frames with possibly variable format from an wmv file
*
** vs_file_wmv IS_A vs_file IS_A vs_base
*
*******************************************************/

#include "vs_file.hpp"


class vs_file_wmv_imp;

class vs_file_wmv: 
  public vs_file
{
public:
  vs_file_wmv(const char* filename);
  virtual ~vs_file_wmv();

//vs_file_util attributes
public:
  static char const* extension(){ return "wmv"; }

//attributes
public:
  virtual int count();
  virtual char const* name();
  virtual const img_fmt& fmt();
  virtual int msDayUtc();
private:
  virtual void getFrameSimple(img_data&);

private:
  vs_file_wmv_imp* pimp;
};

#endif
