#include "vs_grab.hpp"

#include "../util/util_time.hpp"
#include "../util/util_registry.hpp"

#include "../img/img_data.hpp"

#include <limits.h>

////////////////////////
// vs_grab methods

vs_grab::vs_grab():
  t0_(util_time::msDayUtc())
{
}
vs_grab::~vs_grab(){}

int vs_grab::count(){
  return INT_MAX;
}
int vs_grab::msDayUtc(){
  return util_time::msDayUtc()-t0_;
}



////////////////////////
// vs_grab static methods

vs_grab* vs_grab::create(
  const char* name_derived, 
  const CtorArg& arg)
{
  return util::Registry::instance().
    create<vs_grab>(name_derived, arg);
}

vs_grab* vs_grab::createCheck(
  const char* name_derived, 
  const CtorArg& arg)
{
  img_fmt fmt(arg.fmt);

  int w=fmt.width();
  if (w==0) 
    w=384;
  int h=fmt.height();
  if (h==0) 
    h=3*w/4;
  int szpix=fmt.szPixel();
  if (szpix==0) 
    szpix=1;

  CtorArg arg2(arg.board, arg.channel, arg.mode,
    img_fmt(w,h,szpix));

  return create(name_derived, arg2);
}


////////////////////////
// vs_grab_test
#include "../img/access/img_access_fill.hpp"

class vs_grab_test: 
  public vs_grab
{
  img_data img_;
public:
  vs_grab_test(const CtorArg& arg);
  virtual ~vs_grab_test();
  static char const* s_name(){return "test";}
public:
  virtual char const* name(){return s_name();}
  virtual const img_fmt& fmt(){return img_.fmt();}
  virtual void getFrameSimple(img_data& d){d=img_;}
};

vs_grab_test::vs_grab_test(const CtorArg& arg):
  img_(arg.fmt)
{
  img_access_fillCheckboard(img_,50);
}
vs_grab_test::~vs_grab_test(){}


namespace{
  util::RegistryCreator<vs_grab,vs_grab_test> creator;
}

