#ifndef vs_grabUtil_hpp
#define vs_grabUtil_hpp

/******************************************************
*
*        vs_grabUtil.hpp by Sinisa Segvic
*
** low level utilities used by vs_grab components
*
*******************************************************/

namespace vs_grabUtil{
  //conversion from yuv to rgb24
  void yuv444ToRgb(int w, int h, void const* psrc, void* pdst);
  void yuv422ToRgb(int w, int h, void const* psrc, void* pdst);
  void yuv411ToRgb(int w, int h, void const* psrc, void* pdst);
  void yuv422ToGray(int w, int h, void const* psrc, void* pdst);
  //conversion from grayscale to rgb24
  void grayToRgb(int w, int h, void const* psrc, void* pdst);
  //flip image
  void flipVertical(int w, int h, int szpix, void* pdst);
  //simple file IO
  void writePPM(int w, int h, int szpix, void const* bits);
}

#endif
