#include "vs_grab_linux1394.hpp"
#include "vs_grabUtil.hpp"

#include "../img/img_data.hpp"

#include <stdexcept>
#include <iostream>

/*
g++ -g vs_grab_linux1394_test.cpp vs_grab_linux1394.cpp \
  vs_grabUtil.cpp vs_grab.cpp vs_base.cpp \
  ../img/img_data.cpp ../img/access/img_access_fill.cpp \
  ../util/util_registry.cpp ../util/util_time_linux.cpp \
  ../util/util_debug.cpp \
  -ldc1394_control -lraw1394
*/


void getone(vs_grab_linux1394& vs){
  img_data img;
  vs.getFrameSimple(img);
  vs_grabUtil::writePPM(
    img.fmt().width(), 
    img.fmt().height(), 
    img.fmt().szPixel(),
    img.bits()); 
  std::cerr <<"Got frame on " <<vs.msDayUtc() <<"\n";
}

int main(){
  try{
    vs_grab_linux1394 vsg(vs_grab::CtorArg(0,0,0, img_fmt(768,576,3)));
    std::cerr <<"Created vs_grab_linux1394 " 
      <<vsg.fmt().width() <<"x"
      <<vsg.fmt().height()<<"x"
      <<vsg.fmt().szPixel()<<"\n";
    getone(vsg);
    sleep(1);
    for (int i=0; i<10; ++i){
      getone(vsg);
    }
  } catch (std::exception& e){
    std::cerr <<"Caught exception: " <<e.what() <<"\n";
  } catch (char const* str){
    std::cerr <<"Caught exception: " <<str <<"\n";
  }
}
