#ifndef vs_grab_linuxV4L_hpp
#define vs_grab_linuxV4L_hpp

/******************************************************
*
*        vs_grab_linuxV4L.h
*
*  component:
*     vs_grab_linuxV4L
*
** implements the interface to a 
** video4linux video capture device
*
** sources:
** - V4L capture and display test programs by Ben Bridgwater
**   http://planeta.terra.com.br/informatica/gleicon/video4linux/
** - Real Time Image Library (libRTImage)
**   http://www.comp.leeds.ac.uk/vision/software/libRTImage/
*
** vs_grab_linuxV4L IS_A vs_grab
*
** author: Sinisa Segvic
** version 1.0 (2002-12-03)
*
*******************************************************/

#include "vs_grab.hpp"

class V4LDevice;

class vs_grab_linuxV4L: 
  public vs_grab
{
  
//construction
public:
  vs_grab_linuxV4L(const CtorArg& arg);
  virtual ~vs_grab_linuxV4L();

//vs_base attributes
public:
  virtual char const* name();

//operations
public:
  virtual const img_fmt& fmt();
  virtual void getFrameSimple(img_data&);
  virtual int msDayUtc(){return msLastFrame_;}

//vs_grab attributes
public:
  static char const* s_name();

//V4L specific operations
public:

//private implementation
private:
  V4LDevice& cam;
  int msLastFrame_;
};


#endif


