#ifndef vs_grab_macx1394_hpp
#define vs_grab_macx1394_hpp

/******************************************************
*
*        vs_grab_macx1394.h
*
*  component:
*     vs_grab_macx1394
*
** implements the interface to a 
** ieee1394 digital camera on MacOSX
*
** sources:
** - apple documentation
**   http://developer.apple.com/documentation/QuickTime/APIREF/SOURCESV/programmingsummary.htm
**   http://lists.apple.com/archives/firewire/2003/Jul/01/iidcdicitalcamsonmacosx.002.txt
** - apple samples (especially SGDataProcSample)
**   http://developer.apple.com/samplecode/QuickTime/idxMovieCreation-date.html
*
** vs_grab_macx1394 IS_A vs_grab
** author: Sinisa Segvic
*
*******************************************************/

#include "vs_grab.hpp"
#include <boost/scoped_ptr.hpp>

class MacXfwcam;

class vs_grab_macx1394: 
  public vs_grab
{
//construction
public:
  vs_grab_macx1394(const CtorArg& arg);
  virtual ~vs_grab_macx1394();

//vs_base attributes
public:
  virtual char const* name();
  virtual int msDayUtc();

//vs_base operations
public:
  virtual const img_fmt& fmt();
  virtual void getFrameSimple(img_data&);

//vs_grab attributes
public:
  static char const* s_name();

//private implementation
private:
  boost::scoped_ptr<MacXfwcam> pcam;
};


#endif
