#ifndef vs_grab_w32MCI_hpp
#define vs_grab_w32MCI_hpp

/******************************************************
*
*        vs_grab_w32MCI.h
*
*  component:
*     vs_grab_w32MCI
*
** implements a MCI compliant 
** frame grabber (win32 only)
*
** vs_grab_w32MCI IS_A vs_grab
*
** author: Sinisa Segvic
** version 4.0 (2002-02-05)
*
*******************************************************/
#include "vs_grab.hpp"

class vs_grab_w32MCIimp;


class vs_grab_w32MCI: 
  public vs_grab
{
  vs_grab_w32MCI(const vs_grab_w32MCI&);
  const vs_grab_w32MCI& operator=(const vs_grab_w32MCI&);
//construction
public:
  vs_grab_w32MCI(const CtorArg& arg);
  virtual ~vs_grab_w32MCI();

//vs_base attributes
public:
  virtual char const* name();

//Operations
public:
  virtual const img_fmt& fmt();
  virtual void getFrameSimple(img_data&);

//vs_grab attributes
public:
  static char const* s_name();

//MCI specific operations
public:
  void liveWindow(bool);

  void boxDisplay();
  void boxSource();
  void boxFormat();

//private implementation
private:
  vs_grab_w32MCIimp* pimp;
};

#endif

