#ifndef vs_grab_w32PXC_hpp
#define vs_grab_w32PXC_hpp

/******************************************************
*
*        vs_grab_w32PXC.h
*
*  component:
*     vs_grab_w32PXC
*
** implements the Imagenation PXC 
** frame grabber (win32 only)
*
** the singleField ctor argument instructs the
** vs_grab_w32PXC object to consider grabbing 
** only even fields from the video signal
*
** that can be accomplished iff the requested image height 
** is below the half of the maximum signal resolution 
** PAL: 768/2x576/2=384x288; NTSC: 640/2x486/2=320x243
*
** vs_grab_w32PXC IS_A vs_grab
*
** author: Sinisa Segvic
** version 1.0 (2002-02-11)
*
*******************************************************/

#include "vs_grab.hpp"
class vs_grab_w32PXCimp;


class vs_grab_w32PXC: 
  public vs_grab
{
//construction
public:
  vs_grab_w32PXC(
    const CtorArg& arg);
  virtual ~vs_grab_w32PXC();

//vs_base attributes
public:
  virtual char const* name();

//operations
public:
  virtual const img_fmt& fmt();
  virtual void getFrameSimple(img_data&);

//vs_grab attributes
public:
  static char const* s_name();

//PXC specific operations
public:

//private implementation
private:
  vs_grab_w32PXCimp* pimp;

  vs_grab_w32PXC(const vs_grab_w32PXC& other);
  const vs_grab_w32PXC& operator=(const vs_grab_w32PXC&);
};


#endif


