#ifndef win_ann_util_hpp
#define win_ann_util_hpp

#include <vector>
#include <string>
#include <utility>

namespace grid{
  class Pixel;
}

class win_ann_abstract;

struct win_ann_util{
  static void addAim(win_ann_abstract& ann,
    const grid::Pixel& p, int size, 
    int col, int width);
  //phi==0 ==> looking up
  static void addCamera(win_ann_abstract& ann,
    const grid::Pixel& p,
    double phi, int size, 
    int col, char const* comment);
  static void addRectangle(win_ann_abstract& ann,
    const grid::Pixel& p0,
    const grid::Pixel& p1,
    int col, int width);
  static void addEgoAngles(win_ann_abstract& ann,
    double ax, double ay, double az,
    double u0, double v0, double f);
  static void addEpipole(win_ann_abstract& ann,
    double e0, double e1, double e2,
    double u0, double v0, double f);
    
};


#endif
