#include "win_event.hpp"

#include <assert.h>
#include <vector>

////////////////////////////////
// win_event implementation

win_event::win_event(
  Type t, int mods,
  int par1, int par2)
:
  type_ (t),
  mods_ (mods&(Shift|Ctrl|Alt|DoubleClick)),
  par1_(par1),
  par2_(par2)
{
}

win_event::win_event()
:
  type_ (KeyboardAscii),
  mods_ (0),
  par1_(0),
  par2_(0)
{
}

void win_event::assign(
  const win_event_abstract& o)
{
  type_=static_cast<Type>(o.type());
  mods_=o.modifiers();
  par1_=o.par1();
  par2_=o.par2();
}


////////////////////////////////
// win_event_vector implementation

struct win_event_vectorImp{
  std::vector<win_event> vec;
};

win_event_vector::win_event_vector():
  pimp(new win_event_vectorImp)
{}

win_event_vector::~win_event_vector(){}


void win_event_vector::clear(){
  pimp->vec.clear();
}
void win_event_vector::push(
  const win_event_abstract& e)
{
  pimp->vec.push_back(
    dynamic_cast<const win_event&>(e));
}


int win_event_vector::size() const{
  return static_cast<int>(pimp->vec.size());
}
const win_event_abstract& 
win_event_vector::operator[](int i) const{
  assert(i>=0 && 
    i<static_cast<int>(pimp->vec.size()));
  return pimp->vec[i];
}

