#ifndef win_event_hpp
#define win_event_hpp

/******************************************************
*
** win_event by Sinisa Segvic
*
** two concrete classes:
** +win_event:        user event occured in the window 
** +win_event_vector: simple collection of win_events
*
*******************************************************/
#include "win_event_abstract.hpp"
#include <boost/smart_ptr.hpp>

class win_event:
  public win_event_abstract
{
private:
  Type type_;
  int mods_;
  int par1_;
  int par2_;

public:
  win_event();
  win_event(
    Type t, int mods,
    int par1, int par2);
  virtual ~win_event(){}

public:
  virtual int type() const {
    return type_;
  }
  virtual int modifiers() const {
    return mods_;
  }
  virtual int par1() const {
    return par1_;
  }
  virtual int par2() const {
    return par2_;
  }

  virtual void assign(const win_event_abstract&);
};

////////////////////////////
// vector declaration

struct win_event_vectorImp;

class win_event_vector:
  public win_event_vectorAbstract
{
public:
  win_event_vector();
  virtual ~win_event_vector();

  virtual void clear();
  virtual void push(const win_event_abstract& e);
  virtual int size() const;
  virtual const win_event_abstract& operator[](int i)  const;
private:
  boost::scoped_ptr<win_event_vectorImp> pimp;
};




#endif

