#ifndef win_event_abstract_hpp
#define win_event_abstract_hpp

/******************************************************
*
** win_event_abstract by Sinisa Segvic:
*
** two abstract (protocol) classes:
** + win_event_abstract:       an input window event 
** + win_event_vectorAbstract: a collection of win_event_abstract-s
*
*******************************************************/

class win_event_abstract{
public:
  enum Type{
    KeyboardAscii, KeyboardFx, KeyboardArrow, KeyboardEdit,
    MouseLeft, MouseMiddle, MouseRight};
  enum Modifier{
    Shift=1, Ctrl=2, Alt=4,
    DoubleClick=16, AllModifiers=0xff};
public:
  virtual ~win_event_abstract(){}

public:
  virtual int type() const =0;
  virtual int modifiers() const =0;
  virtual int par1() const =0;
  virtual int par2() const =0;

  virtual void assign(const win_event_abstract&) =0;
};


class win_event_vectorAbstract{
public:
  virtual ~win_event_vectorAbstract(){}
public:
  virtual void clear() =0;
  virtual void push(const win_event_abstract& e) =0;
  virtual int size() const =0;
  virtual const win_event_abstract& operator[](int i)  const =0;
};
#endif

