#include "win_base.hpp"

#include "../../img/img_data.hpp"
#include "../../util/util_registry.hpp"

#include <vector>

///////////////////////////
// private helpers

namespace{

void checkSize(
  win_base& win,
  const img_data& image)
{
  if (
    image.fmt().width()  != win.width() ||
    image.fmt().height() != win.height())
  {
    //std::cerr 
    //  <<image.fmt().width() <<" " 
    //  <<image.fmt().height()<<"\n";
    win.size(image.fmt().width(), 
      image.fmt().height());
  }
}

}//unnamed namespace end 



///////////////////////////
// construction

win_base::win_base(){}

win_base::~win_base(){}


////////////////
// img transfer

void win_base::setImg(
  const img_data& image)
{
  checkSize(*this, image);
  putImg(image);
}

void win_base::setImgAnn(
  const img_data& image, 
  const win_ann_abstract& ann)
{
  checkSize(*this, image);
  putImgAnn(image, ann);
}

void win_base::setAnn(
  const win_ann_abstract& ann)
{
  putAnn(ann);
}
////////////////////////
// win_base static methods

win_base* win_base::create(
  const char* name_derived, 
  const CtorArg& arg)
{
  return util::Registry::instance().
    create<win_base>(name_derived, arg);
}


