#ifndef win_wrap_hpp
#define win_wrap_hpp

/******************************************************
*
**  win_wrap.hpp  by Sinisa Segvic
*
**  an instantiable wrapper for win_base class 
**  which delegates operations to:
**  + win_w32 (w32)
**  + win_x   (unix)
*
*******************************************************/

#include "win_base.hpp"

class win_wrap:
  public win_base
{
public:
  win_wrap(const char* caption, int cx, int cy);
  ~win_wrap();
  
  virtual char const* name(){return "wrap";}
  virtual int width();
  virtual int height();

  virtual void position(int, int);
  virtual void size(int, int);
  virtual void caption(char const*);

public:
  virtual void flash();
private:
  virtual void putImg(const img_data&);
  virtual void putImgAnn(const img_data&, const win_ann_abstract&);
  virtual void putAnn(const win_ann_abstract&);
public:
  virtual bool event(int& iterator, win_event_abstract&) const;
private:
  win_base* pwin;
};

#endif

