#ifndef win_w32_hpp
#define win_w32_hpp

//////////////////////////////////////////////
// win_w32 
// Encapsulates implementation of a ms win32 window

#include "../root/win_base.hpp"

class img_data;

struct win_w32_imp;

class win_w32: public win_base{
public:    
  win_w32(const CtorArg& arg);
protected:
  virtual ~win_w32();

public:
  static char const* s_name();
  virtual char const* name(){return s_name();};

public:    
  virtual int width();
  virtual int height();

  virtual void position(int, int);
  virtual void size(int, int);
  virtual void caption(char const*);

//window output
public:    
  virtual void flash();
private:    
  virtual void putImg(const img_data&);
  virtual void putImgAnn(const img_data&, const win_ann_abstract&);
  virtual void putAnn(const win_ann_abstract&);

//window input
public:    
  virtual bool event(int& id, win_event_abstract&) const;


private:
   win_w32_imp* pimp;
};

#endif
