#ifndef win_x_hpp
#define win_x_hpp

/******************************************************
 *
 ** win_x by Sinisa Segvic:
 *
 ** Encapsulates implementation of an X window
 *
 ******************************************************/


#include "../root/win_base.hpp"

class win_ann_abstract;
class img_data;

struct win_x_imp;

class win_x: 
  public win_base{
public:    
  win_x(const CtorArg& arg);
protected:
  virtual ~win_x();

public:
  static char const* s_name();
  virtual char const* name(){return s_name();};
public:
  // window properties (get)
  virtual int width();
  virtual int height();

  // window properties (set)
  virtual void position(int, int);
  virtual void size(int, int);
  virtual void caption(char const*);

public:
  //window output 
  virtual void flash();

  //window input
  virtual bool event(
    int& iterator, win_event_abstract&) const;

private:
  //window output 
  //img should be width() x height()
  virtual void putImg(
    const img_data&);
  virtual void putImgAnn(
    const img_data&, 
    const win_ann_abstract&);
  virtual void putAnn(
    const win_ann_abstract&);

  win_x_imp* pimp;
};

#endif

