#ifndef win_x_renderer_hpp
#define win_x_renderer_hpp

#include <X11/Xlib.h>

/******************************************************
 *
 *  component:
 **    win_x_renderer
 *
 ** base class of objects for rendering 
 ** rgb and gray images on X windows systems
 *
 ** derived classes use win_x_connection!
 *
 ** author: Sinisa Segvic
 ** version 1.0 (2002-04-04)
 *
 ******************************************************/

class img_data;

class win_x_renderer{
public:
  virtual ~win_x_renderer();
  // renders the working image to the given Drawable
  virtual void operator()(const img_data&, Drawable d) =0;
  // renders the default image to the given Drawable
  virtual void operator()(int w, int h,  Drawable d) =0;
};


#endif

