#ifndef win_x_renderer_imlib_hpp
#define win_x_renderer_imlib_hpp

#include "win_x_renderer.hpp"

#include <boost/smart_ptr.hpp>

/******************************************************
 *
 *  component:
 **    win_x_renderer_imlib
 *
 ** rendering images on X windows systems using Imlib
 *
 ** uses win_x_connection
 *  
 ** author: Sinisa Segvic
 ** version 1.0 (2002-04-04)
 *
 ******************************************************/

class win_x_renderer_imlibImp;

class win_x_renderer_imlib:
  public win_x_renderer{
public:
  win_x_renderer_imlib();
  virtual ~win_x_renderer_imlib();

  virtual void operator()(const img_data&, Drawable);
  virtual void operator()(int w, int h, Drawable);

private:
  boost::scoped_ptr<win_x_renderer_imlibImp> pimp;
};


#endif

