#ifndef win_x_thread_hpp
#define win_x_thread_hpp

/*************************************
 * win_x_thread 
 *
 * * synchronizes win_base requests and
 *   dispatches them to the private 
 *   implementation object (pimp)
 * * pimp manages multiple X windows 
 *   running in a separate thread
 *
 *************************************/

class win_ann_abstract;
class win_event_abstract;
class img_data;

struct win_x_thread_imp;

class win_x_thread{ 

//construction and access (we are singleton)
private:
  win_x_thread();
  ~win_x_thread();
public:
  static win_x_thread& instance();

//operations
public:    
  // window creation
  int createWindow(int cx, int cy);
  void destroyWindow(int id);

  // window properties
  void position(int id, int,int);
  void size(int id, int,int);
  void caption(int id, char const*);

  //window input
  bool queryEvent(int id, int& iterator, 
    win_event_abstract& e);

  // window output
public:
  void putImg(int id, const img_data&);
  void putImgAnn(int id, const img_data&,
    const win_ann_abstract&);
  void putAnn(int id, 
    const win_ann_abstract&);
  void flash(int id);

private:
   win_x_thread_imp* pimp;
};

#endif

