#include "RGBtoHSI.h"




double Stupnjevi_Radijani(double stupnjevi) {
  const double PI1=4*atan(1.0);
  return stupnjevi * PI1 / 180;
}


double Radijani_Stupnjevi(double radijani) {
  const double PI1=4*atan(1.0);
  return radijani * 180 / PI1;
}

void pretvorbaRGB_HSI(const double r, const double g, const double b, float& c_h, float& c_s, float& c_i)
{
	//printf ("\n\n%d", c_h);
	
	const double PI1 = 4 * atan(1.0);
	//printf ("%lf", PI1);

	const double rgb = r + g + b;

	double h = 0, s = 0, i = 0;
	
	double min = r;
	if (g < min) min = g;
	if (b < min) min = b;
	
	i = (double) (rgb / 3);
	s = 1 - (3 / rgb) * min;
	
	if (s <= 0) {
	    h = PI1;
	}
	else {
		h = ( (r - g) + (r - b) ) / 2;
		h = acos( h / sqrt( pow((r-g), 2) + ( (r - b) * (g - b) ) ) );

		if ((b > g)) {
		h = Stupnjevi_Radijani(360) - h;
		}
	}
		//printf("\n\n%d, %d", &c_h, &c_s);
		c_h = h;
		c_s = s;
		c_i = i;
		//printf ("\n\n%f, %d, %d, %d", c_i, &c_i, &c_s, &c_h);
}

void RGBtoHSI(int width, int height, const unsigned char* psrc, float* pdst)
{
	int x, y, z = 0;
	double r = 0, g = 0, b = 0;
	float* pdst1 = (float*) pdst;
	
	for (y = 0; y < height; y++) {
		for (x = 0; x < width; x++, z += 3) {
				r = psrc[z];
				g = psrc[z + 1];
				b = psrc[z + 2];
				//printf ("\n\nr=%d, g=%d, b=%d", r,g,b);
				//printf ("\n\npdst1[z]=%d", pdst1[z]);
				pretvorbaRGB_HSI(r, g, b, pdst1[z], pdst1[z + 1], pdst1[z + 2]);
				pdst[z] = (float) pdst1[z];
				pdst[z + 1] = (float) pdst1[z + 1];
				pdst[z + 2] = (float) pdst1[z + 2];
		}
	}
}
