#include "../alg/alg_base.hpp"

#include "../util/util_registry.hpp"

#include "../img/img_util.hpp"
#include "../img/img_vector.hpp"

#include <iostream>

////////////////////////////////////
// alg_empty declaration

class alg_empty: 
  public alg_base
{
public:
  alg_empty(const CtorArg& arg);
  virtual ~alg_empty();
public:
  virtual char const* name(){return s_name();}
  static char const* s_name(){return "empty";}
private:
  virtual void process( 
    const img_vectorAbstract& src, 
    const win_event_vectorAbstract& events,
    int msDayUtc); 
private:
  virtual int countDst(); // >=1!
  virtual const img_data& imgDst(int id);
private:
  img_vector imgs_;
};

////////////////////////////////////
// static registry creator object

namespace{
  util::RegistryCreator<alg_base,alg_empty> creator;
} // unnamed namespace end

  
////////////////////////////////////
// alg_empty implementation

alg_empty::alg_empty(const CtorArg& arg):
  imgs_(2)
{
}

alg_empty::~alg_empty(){}

void alg_empty::process(
  const img_vectorAbstract& src,
  const win_event_vectorAbstract&, int)
{
  imgs_[0]=src[0];
  imgs_[1].reformat(src[0].fmt());
  img_util::fillBits(imgs_[1], 0);
}

int alg_empty::countDst(){
  return 2;
}

const img_data& alg_empty::imgDst(int id){
  checkId(id, "alg_empty::imgDst");
  return imgs_[id];
}

