#include "narastanje.h"

//z= y*width*3+x*3

void flood_fill ( int width, int height, float* imgBin,  float boja, int x, int y)
{
	int a, b, c, z;
	
	//oznaci piksel
	z= y*width*3+x*3;
	imgBin[z+2] = boja;

	//gore
	if (y>0){ //provjeravanje da nismo u prvom redu;
		z= (y-1)*width*3+x*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0],  boja, x, y-1);
		}
	}
	//gore-desno
	if (y>0 && x<(width-1) ){ //provjeravanje da nismo u prvom redu i zadnjem stupcu;
		z= (y-1)*width*3+(x+1)*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0], boja, x+1, y-1);
		}
	}
	//desno
	if (x<(width-1)){ //provjeravanje da nismo u zadnjem stupcu;
		z= (y)*width*3+(x+1)*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0], boja, x+1,y );
		}
	}

	//dolje-desno
	if ( y<(height-1) &&  x<(width-1)){ //provjeravanje da nismo u zadnjem redu i zadnjem stupcu;
		z= (y+1)*width*3+(x+1)*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0],  boja, x+1, y+1);
		}
	}
	//dolje
	if ( y<(height-1) ){ //provjeravanje da nismo u zadnjem redu;
		z= (y+1)*width*3+x*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0],  boja, x, y+1);
		}
	}
	//dolje-lijevo
	if ( y<(height-1) &&  x>0){ //provjeravanje da nismo u zadnjem redu i prvom stupcu;
		z= (y+1)*width*3+(x-1)*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0],  boja, x-1, y+1);
		}
	}
	//lijevo
	if ( x>0){ //provjeravanje da nismo u prvom stupcu;
		z= (y)*width*3+(x-1)*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0],  boja, x-1, y);
		}
	}
	//gore-lijevo
	if ( y > 0 && x>0){ //provjeravanje da nismo u prvom retku i prvom stupcu;
		z= (y-1)*width*3+(x-1)*3;
		if (imgBin[z+2] == 255){
			flood_fill (width, height, &imgBin[0],  boja, x-1, y-1);
		}
	}
}



int *narastanje (int width, int height, float* imgBin)
{
	int n, *nizrj, k, gore,dolje, lijevo,desno, x,y,z;
	float boja;
	//inicijalizacija
	k = 4;
	nizrj = (int*) malloc (k*sizeof(int));
	nizrj[k-1] = nizrj[k-2] = nizrj[k-3] = nizrj[k-4] = -1;

	boja = 256;
	// trai piksel
	for (z=y = 0; y < height; y++){
		for (x = 0; x < width; x++, z +=3){
			if (imgBin[z+2] == 255) {
				//piksel pronadjen, oznaci cijelu nakupinu piksela
				flood_fill (width, height, &imgBin[0], boja, x, y);
				boja++;
			}
		}
	}
	printf("%f", boja);

	boja=255;
	n = 1;
	while (n>0){
		gore = height;
		dolje = desno = -1;
		lijevo = width;
		boja++;								//postavi sljedecu vrijednost
		n = 0;								// resetiraj brojac
		for (z = y= 0; y<height; y++){
			for (x=0; x<width; x++, z+=3){
				if (imgBin[z+2] > 255){
					//printf ("%f ",imgBin[z+2]);
					if (imgBin[z+2] == boja){	//trazi piksel iz skupine s vrijednoscu boja
						n++;					// ako je piksel pronadjen povecaj brojac za 1
						if ( y<=gore)			// pogledaj da li je ovaj piksel rubni
							gore = y;
						if (y >=dolje)
							dolje = y;
						if ( x<= lijevo)
							lijevo = x;
						if (x >= desno)
							desno = x;
					}
				}
			}
		}

		if(n>70){
			printf ("\n n = %d\n",n );
			k = k+4;
			nizrj = (int*) realloc (nizrj, k*sizeof(int));
			nizrj[k-1] = nizrj[k-2] = nizrj[k-3] = nizrj[k-4] = -1;
			nizrj[k-5] = dolje;
			nizrj[k-6] = desno;
			nizrj[k-7] = gore;
			nizrj[k-8] = lijevo;
		}
	}
	//postavi na pocetne vrijednosti
	for (z=y = 0; y < height; y++){
		for (x = 0; x < width; x++, z +=3){
			if (imgBin[z+2] >255){
				//printf ("%f ",imgBin[z+2]);
				imgBin[z+2] = 255;
			}
		}
	}
	return nizrj;
}




